#include <stdio.h>
#include <string.h>
#include <bzlib.h>


void help()
{
 printf("   DIC_EN  DIC_RU.\n");
 printf(" :    (   )");
 printf("   dwa  .\n");
 printf(":\n\n");
 printf("$ export DIC_EN=/usr/share/dic/en1.dwa:~/en2.dwa\n");
 printf("$ export DIC_RU=~/ru2en.dwa\n");
 printf("$ dic \n");
 printf("hello\n\n");
 printf(" 2       ~/.bashrc\n");
 printf(" ~ -  .\n");
 printf("       , ");
 printf("  Σ    ,  -    ..\n");
 printf("   \"dic - \",     ");
 printf("  .\n");
}

FILE* f = NULL;

int bzgetc(FILE* f)
{
 int c = 0;
 int n;
 n = BZ2_bzread(f,&c,1);
 if(n==0) c = EOF;
 return c;
}

FILE* bzopen(const char* name, const char* mode){ return BZ2_bzopen(name, mode);}
int bzclose(FILE* f){ BZ2_bzclose(f); return 0;}

int main(int ac, char** av)
{
 FILE* (*xopen)(const char*,const char*);
 int (*xgetc)(FILE*);
 int (*xclose)(FILE*);
 
 char* en, *ru, slovo[512], *path, *file;
 int flag = 0, najden = 0, najden_g = 0;
 char buf[512];
 int leng;
 
 if(ac==1)
 {
  fprintf(stderr,": \"dic \"  \"dic -h\"\n"); 
  return 1;
 }

 av++;
 
 if(strcmp(*av,"-h")==0)
 {
  printf("dic - \n");
  printf("dic -h -   \n");
  printf("dic -v -   \n");
  printf("dic [-]  -  \n\n");
  printf("     :\n");
  help();
  return 0;
 }

 if(strcmp(*av,"-v")==0)
 {
  printf(": 1.2\n");
  printf(": ` \n");
  printf("e-mail: dart_vader@kid.stu.cn.ua\n");
  printf(": kid.stu.cn.ua/~dart_vader\n");
  printf("16/10/2005\n");
  return 0;
 }
 
 if(strcmp(*av,"-")==0) flag = -1, av++;
 
 for(; *av; av++) strcpy(slovo, *av);
 leng = strlen(slovo);

 en = (char*) getenv("DIC_EN");
 ru = (char*) getenv("DIC_RU");
 
 if(ru==NULL || en==NULL)
 { 
  help();
  return 1;
 }

 path = strdup(slovo[0]<0 ? ru:en);
 
 for(file = strtok(path,":"); file; file = strtok(NULL,":"))
 {
  char* mode;
  char* yt = strrchr(file,'.');
  int c = ' ';
  
  if( !yt ) goto NX;
  if( strcmp(yt, ".bz2")==0 )
  {
   xopen = bzopen;
   xgetc = bzgetc;
   xclose = bzclose;
   mode = "r9";
  }
  else
  {
   NX:
   xopen = fopen;
   xgetc = fgetc;
   xclose = fclose;
   mode = "rb";
  }

  f = xopen(file, mode);
  if(!f)
  {
   fprintf(stderr, "   `%s'  ,         %s\n", file, slovo[0]<0 ? "DIC_RU":"DIC_EN");
   return 1;
  }
  
  while( c!=EOF )
  {
   char* s = buf;
   while( isspace(c) ) c = xgetc(f);
   while( !isspace(c) )
   { 
    if(c==EOF) goto NEXT;
    *s++ = c; c = xgetc(f); 
   }
   *s = '\0';
   
   if(strcmp(slovo,buf)==0)
   {
    najden = najden_g = -1;
    printf("%s", buf);
    s = buf;
    while(c!='=')
    {
     if(c==EOF){ fprintf(stderr," `%s' ģ\n",file); return 1;}
     *s++ = c;
     c = xgetc(f);
    }
    *s = '\0';
    printf("%s-", buf);
    c = xgetc(f);
    while(c!='\n' && c!=EOF){ putchar(c==';'?'\n':c); c = xgetc(f);}
    putchar('\n');
   }
   else
   { 
    if(najden) break;
    while(c!='\n' && c!=EOF) c = xgetc(f);
   }
  }
  NEXT:
  xclose(f);
  if(najden && !flag) return 0;
  najden = 0;
 }

 if(!najden_g) printf("  .\n");
 
 return 0;
}
